"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogAdvice = void 0;
const logmanager_1 = require("./logmanager");
class LogAdvice {
    // 作为前置通知
    async beforeLogger() {
        logmanager_1.LogManager.logger.log({ levelStr: 'info' }, arguments[0].clazz.name + '.' + arguments[0].methodName + '执行', '开始时间：' + new Date(), '方法参数：' + arguments[0].params);
    }
    // 作为返回通知
    async returnLogger() {
        logmanager_1.LogManager.logger.log({ levelStr: 'info' }, '返回时间：' + new Date(), '返回值：' + arguments[0].returnValue);
    }
    // 作为异常通知
    async throwLogger() {
        logmanager_1.LogManager.logger.log({ levelStr: 'info' }, '异常时间：' + new Date(), '异常值：' + arguments[0].throwValue);
    }
}
exports.LogAdvice = LogAdvice;
//# sourceMappingURL=logadvice.js.map