"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LaunchHookManager = void 0;
const instancefactory_1 = require("../main/instancefactory");
/**
 * 启动后执行钩子对象管理器
 * @since 0.3.5
 */
class LaunchHookManager {
    /**
     * 初始化
     * @param cfg [{"clazz":实例类,"method":方法名,params:参数数组}...]
     */
    static init(cfg) {
        if (!instancefactory_1.InstanceFactory.hasClass(cfg.clazz)) {
            instancefactory_1.InstanceFactory.addInstance(cfg.clazz);
        }
        this.hooks.push(cfg);
    }
    /**
     * 批量执行hook方法
     */
    static async run() {
        let h;
        for (h of this.hooks) {
            await instancefactory_1.InstanceFactory.exec(h.clazz, h.method, h.params);
        }
    }
}
exports.LaunchHookManager = LaunchHookManager;
/**
 * hook实例数组
 */
LaunchHookManager.hooks = new Array();
//# sourceMappingURL=launchhookmanager.js.map