"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CpuFactory = void 0;
const application_1 = require("../tools/application");
const requestqueue_1 = require("../web/requestqueue");
class CpuFactory {
    /**
     * 创建Interval对象
     * @returns
     */
    static openInterval() {
        if (this.iterval) {
            return;
        }
        this.oldcpu = this.getCpu();
        this.iterval = setInterval(this.getCpuUseRate, 1000);
    }
    /**
     * 关闭Interval对象
     */
    static closeInterval() {
        if (this.iterval) {
            clearInterval(this.iterval);
            this.iterval = null;
        }
    }
    /**
     * 30秒服务器没请求关闭定时器
     * 获取CPU使用率，更改RequestQuene中的canHandle
     */
    static getCpuUseRate() {
        let now = CpuFactory.getCpu();
        let idle = now.idle - CpuFactory.oldcpu.idle;
        let total = now.total - CpuFactory.oldcpu.total;
        let rate = 1 - idle / total;
        CpuFactory.oldcpu = now;
        // console.log("cpu rate",rate,'----',CpuFactory.oldcpu);
        CpuFactory.quenelen = requestqueue_1.RequestQueue.queue.length === 0 ? CpuFactory.quenelen + 1 : 0;
        if (rate > 0.75) {
            requestqueue_1.RequestQueue.setCanHandle(false);
        }
        else {
            requestqueue_1.RequestQueue.setCanHandle(true);
            if (CpuFactory.quenelen === 30) {
                CpuFactory.quenelen = 0;
                CpuFactory.closeInterval();
            }
        }
    }
    /**
     * 获取cpu 信息
     * @returns
     */
    static getCpu() {
        let cpus = application_1.App.os.cpus();
        let idle = 0;
        let total = 0;
        let item;
        for (let i = 0; i < cpus.length; i++) {
            item = cpus[i].times;
            idle += item.idle;
            total = total + item.user + item.nice + item.sys + item.irq;
        }
        return { idle: idle, total: total + idle };
    }
    static getMemory() {
    }
}
exports.CpuFactory = CpuFactory;
/**
 * 记录requestQuene.quene连续为空的秒数，不连续置0
 */
CpuFactory.quenelen = 0;
//# sourceMappingURL=cpufactory.js.map